/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.listjoinerusingstreams;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 *
 * @author omozegieaziegbe
 */
public class ListJoinerUsingStreams {

    public static String joinWithCommasAnd(List<String> elements) {
        
        int size = elements.size();
        if (size <= 1) {
            return String.join("", elements);
        } else {
            String commaSeparated = elements.subList(0, size - 1).stream().collect(Collectors.joining(", "));
            return String.join(" and ", commaSeparated, elements.get(size - 1));
        }
    }
    
    public static void main(String[] args) {
        
        List<String> colors = new ArrayList<>();
        colors.add("red");
        colors.add("blue");
        colors.add("green");
        colors.add("yellow");

        System.out.println("Using Streams: " + joinWithCommasAnd(colors)); 
    }
}
